Title   Init pci code

                        ; -> cf=0
                        ; -> cf=1+ds:si=error message
                        ; other registers modified
a_proc                  init_pci

IFDEF USE_OEMHLP

IFNDEF DO_NOT_USE_OEMHLP2
                        ; attach to OEMHLP$/OEMHL2$ driver for most PCI access
                        mov bx,Offset drivername_OEMHLP2
                        mov di,Offset attach_table
                        mov dl,DevHlp_AttachDD
                        call DeviceHelp
                        jnc @@have_oemhlp
ENDIF ; -DO_NOT_USE_OEMHLP2

                        mov bx,Offset drivername_OEMHLP
                        mov di,Offset attach_table
                        mov dl,DevHlp_AttachDD
                        call DeviceHelp
                        mov si,Offset attach_oemhlp_failed
                        jc @@init_pci_failed
  @@have_oemhlp:
                        mov eax,DWord Ptr attach_table.IDC_IP_ring0
                        mov OEMHLP_IDC,eax
                        mov ax,attach_table.IDC_DS_ring0
                        mov OEMHLP_DS,ax
                        clc
ELSE    ; -USE_OEMHLP

IFDEF OS2
                        ; allocate selector for PCI BIOS
                        push es
                          push ds               ; es:di=@selector array
                          pop es
                          mov di,Offset BIOS_Selector
                          mov cx,1              ; 1 selector
                          mov dl,DevHlp_AllocGDTSelector
                          call DeviceHelp
                        pop es
                        mov si,Offset errmsg_AllocGDTSelectors
                        jc @@init_pci_failed

                        ; make PCI BIOS available:
                        mov eax,0000f0000h      ; physical f000:0000
                        mov ecx,0ffffh          ; 64 KB
                        mov si,BIOS_Selector
                        mov dh,5                ; Ring 0, read+execute, 16 bit
                        mov dl,DevHlp_PhysToGDTSel
                        call DeviceHelp
                        mov si,Offset errmsg_PhysToGDTSel
                        jc @@init_pci_failed
ELSE ; DOS
                        clc
ENDIF ; DOS

ENDIF ; -USE_OEMHLP
  @@init_pci_failed:
                        ret
a_endp                  init_pci

