Title   IOCtl subfunction : configure device/tree

;

; es:bx=@request packet
; fs:si=@parameter packet

a_proc                  ioctl_config
                        pushad

                          STEP <crlf,'ioctl_config.entry'>


                          ; busy, can not block - try again later...
                          mov es:RequestBlock[bx].Request_Packet_Status,08014h ; "Device Already in Use"
                          bts pciconf_busy,0
                          jc @@ret


                          ; set parameters from parameter record
                          mov ax,fs:[si].pci_address
                          mov cfg_pci_address,ax
                          mov ax,fs:[si].pci_address_mask
                          mov cfg_pci_address_mask,ax
                          mov al,fs:[si].para_recursive
                          mov cfg_recursive,al
                          mov al,fs:[si].para_power
                          mov cfg_power,al
                          mov al,fs:[si].para_resources
                          mov cfg_resources,al
                          mov al,fs:[si].para_noirq
                          mov cfg_noirq,al

;<<   must set allow_BAR_modification to true (temporary)?

                          call do_config

                          sub ax,ax
                         ;mov ax,0800ch         ; general failure
                         ;cmp fs:[si].???,(success)
                         ;if_e <sub ax,ax>      ; no error
                          mov es:RequestBlock[bx].Request_Packet_Status,ax

                          mov pciconf_busy,0
  @@ret:

                          STEP 'ioctl_config.exit'

                        popad
                        ret
a_endp                  ioctl_config

;

